// BotenAnna
// code by jph

import java.io.*;
import java.lang.*;
import java.util.*;

public class BotenAnna
implements Runnable
{
  volatile long[] param;
  static final int COUNTRY             =0;
  static final int MAX_LINKS_IN_QUEUE  =1; // total number of webpages to visit
  static final int MAX_LINKS_PER_SERVER=2;
  static final int MAX_LINES_PER_LINK  =3;
  static final int MAX_BYTES_PER_LINK  =4;
  static final int MAX_BYTES_PER_LINE  =5;
  static final int CONNECT_TIMEOUT     =6;
  static final int READ_TIMEOUT        =7;
    
  static final int HASH_DOM=10000;
  static final int HASH_ADR=50000;
  static final int HASH_EML=40000;
  static final int LIST_SLEEP=10;
  
  static final String[] _LINKS_PER_SERVER={"5","10","50","100","500","1000","5000"};
  static final String[] _COUNTRY={"","ar","at","au","bo","ca","ch","cn","co","de","ec","es","fi","fr","ie","it","mx","nz","pe","se","uk","us","uy","ve","za"};
  static final String[]  _CLASS={"",".ac",".biz",".co",".com",".edu",".gov",".govt",".info",".int",".mil",".net",".org"};
  volatile boolean[] visit;
  
  volatile long[] count;
  static final int CONTACTED_NOW=0;
  static final int CONTACTED=1;
  static final int CONNECTED=2;
  static final int COMPLETED=3;
  
  boolean log_file;
  volatile int system_out;
  static final int DOM=0;
  static final int LOG=0;
  static final int ADR=1;
  static final int EML=2;
  static final int CLS=3;
  static final int SRV=4;
  static final int DNY=8;
  static final int EXC=16;
  
  public static final Random myRandom=new Random(System.currentTimeMillis());
  
  Hashtable[] myHashtable;
  HashSet[] myHashSet;
  LinkedList myLinkedList;  
  BufferedWriter[] myBufferedWriter;  
  Thread myThread;
  long session;
  volatile boolean myBoolean=true;  
  volatile String myCountry;
  
  public BotenAnna() {
    int c1;
    myHashtable=new Hashtable[3];
    myHashtable[DOM]=new Hashtable(HASH_DOM*2);
    myHashSet=new HashSet[4];    
    myHashSet[DOM]=new HashSet(HASH_DOM*2);
    myHashSet[ADR]=new HashSet(HASH_ADR*2);
    myHashSet[EML]=new HashSet(HASH_EML*2);
    myHashSet[CLS]=new HashSet();
    for (c1=0;c1<_CLASS.length;c1++)
      myHashSet[CLS].add(_CLASS[c1]);
    myLinkedList=new LinkedList();
    myBufferedWriter=new BufferedWriter[3];
    param=new long[10];
      param[MAX_LINKS_IN_QUEUE]=500;
      param[MAX_LINKS_PER_SERVER]=100;
      param[MAX_LINES_PER_LINK]=1500;
      param[MAX_BYTES_PER_LINK]=50000;
      param[MAX_BYTES_PER_LINE]=2000;  
      param[CONNECT_TIMEOUT]=8000;
      param[READ_TIMEOUT]=8000;
    count=new long[4];
    visit=new boolean[_CLASS.length];
    for (c1=0;c1<_CLASS.length;c1++) 
      visit[c1]=true;
    log_file=true;
    system_out=EML;
    session=System.currentTimeMillis();  // should be in myThread_start()
    myCountry="";
  }
  
  public void set(int myInt,long myLong) {
    param[myInt]=myLong;
  }

  public void myThread_start() {    
    myThread=new Thread(this);
    myThread.start();
  }

  public void run() {
    int c1;
    String myString;
    NodeAnalysis myNodeAnalysis;    
    try {
      myBufferedWriter[LOG]=new BufferedWriter(new FileWriter("data/"+session+"_log.txt"));
      myBufferedWriter[EML]=new BufferedWriter(new FileWriter("data/"+session+"_eml.txt"));
      myBufferedWriter_write("#PROGRAM START\n "+new Date()+"\n");
      try {
        while (myBoolean) {
          if (0<myLinkedList.size()) {
            myString=(String)myLinkedList_poll();
            myNodeAnalysis=new NodeAnalysis(this,myString);
      		  if ((system_out&ADR)==ADR)
              System.out.println(myString);
          }
          myThread.sleep(LIST_SLEEP);
        }
        myThread.sleep(500);
      } catch(InterruptedException myInterruptedException) {
        System.out.println(myInterruptedException);
      }
      myBufferedWriter_write("#PROGRAM STOP\n "+new Date()+"\n");
      myBufferedWriter[EML].close();
      myBufferedWriter[LOG].close();
      log_file=false;
      String myServer;
      myBufferedWriter[LOG]=new BufferedWriter(new FileWriter("data/"+session+"_sta.txt"));
      Iterator myIterator=myHashSet[DOM].iterator();
      while (myIterator.hasNext())                
        if (myHashtable[DOM].containsKey(myServer=(String)myIterator.next()))
          myBufferedWriter[LOG].write(myServer+" "+myHashtable[DOM].get(myServer)+"\n");      
      myBufferedWriter[LOG].close();
      System.out.println("\n all data saved.\n thank you!\n  Jan\n");
		} catch (IOException myIOException) {
			System.out.println(myIOException);
		}				
  }

  String getServer(String myAddress) {
    int cc,cs,c1,c2,c3;
    String myServer;
    String myClass;
    cc=myAddress.indexOf(58); // :
    cs=myAddress.indexOf(47,8); // /
    if (2<cc&&cc+3<cs) {
      myServer=myAddress.substring(cc+3,cs).toLowerCase();;
      c1=myServer.lastIndexOf(46);      // .uk
      if (c1<1)
        return ""; // error
      c2=myServer.lastIndexOf(46,c1-1); // .co
      if (c2<0)
        return myServer;
      if (!myHashSet[CLS].contains(myServer.substring(c2,c1)))
        return myServer.substring(c2+1);
      c3=myServer.lastIndexOf(46,c2-1); // .co
      if (c3<0)
        return myServer;        
      else
        return myServer.substring(c3+1);
    }
    return "";
  }
  
  synchronized void myLinkedList_add(String myAddress) {
    int c1,cnt=0;    
    String myServer;
    String myLocale;
    myServer=getServer(myAddress);
    if (myServer.endsWith(myCountry)) {
      for (c1=0;c1<myAddress.length();c1++)
        if (46<myAddress.charAt(c1)&&myAddress.charAt(c1)<58) // /0-9
          cnt++;
          
      // the condition below enforces
      // that the character u appears in the
      // domain name, for instance:
      //    vanguardia.es [searched]
      //    terra.es      [not searched]
      // which might be helpful to concentrate
      // on university domains
      if (myServer.indexOf(117)<0) // 117 = u
        return;
        
      myLocale=myServer.substring(0,myServer.length()-myCountry.length()-1);      
      for (c1=0;c1<_CLASS.length;c1++)
        if (visit[c1]&&myLocale.endsWith(_CLASS[c1])) {
          int myInt=0;
          myHashSet[DOM].add(myServer);
          if (myHashtable[DOM].containsKey(myServer)) // count myAddress per myDomain
            myInt=((Integer)myHashtable[DOM].get(myServer)).intValue();
          if (!myHashSet[ADR].contains((Object)myAddress)&&
              myInt<param[MAX_LINKS_PER_SERVER]&&
              myLinkedList.size()<param[MAX_LINKS_IN_QUEUE] -cnt*1 -myInt/1000 -myAddress.length()/12
             ) {            
            myHashtable[DOM].put(myServer,new Integer(++myInt));
            myHashSet[ADR].add((Object)myAddress); // consider myAddress visited
            myLinkedList.add((Object)myAddress); // enqueue myAddress
          	if ((system_out&SRV)==SRV)
               System.out.println(myServer);            
          }
          return;
        }
    }
    if ((system_out&DNY)==DNY)
      System.out.println(myServer);
  }

  synchronized void myBufferedWriter_write(String myString) {
    if (log_file)
      try {
        myBufferedWriter[LOG].write(myString);
		  } catch (IOException myIOException) {
		  	System.out.println(myIOException);
		  }
  }

  synchronized String myLinkedList_poll() {
    return (String)myLinkedList.poll();
  }
  
  // myEmail should be trim().lowerCase() without ?subject=...
  synchronized void suggestMail(String myEmail,String myTitle) {
    int c1;
    if (myHashSet[EML].add((Object)myEmail)) {
      try {
        myBufferedWriter[EML].write(myEmail+" "+myTitle+"\n");                
		  } catch (IOException myIOException) {  		  
		  	//System.out.println(myIOException);
		  }        
		  if ((system_out&EML)==EML)
        System.out.println(myEmail);
    }
  }
  
  synchronized void reduce(HashSet myHashSet) {
    Iterator myIterator=myHashSet.iterator();
    while (myIterator.hasNext())
      if (myRandom.nextInt(2)==0) {
        myIterator.next();
        myIterator.remove();    
      } else
        myIterator.next();
  }
  
  synchronized void reduce_DOM() {
    Iterator myIterator=myHashSet[DOM].iterator();
    while (myIterator.hasNext())
      if (myRandom.nextInt(2)==0) {
        myHashtable[DOM].remove(myIterator.next());
        myIterator.remove();
      } else
        myIterator.next();
  }
}
