// NodeAnalysis
// code by jph

import java.io.*;
import java.lang.*;
import java.net.*;
import java.util.*;

class NodeAnalysis
implements Runnable
{
  static final String DELIMITER=" '`:;*$@%!?=&+,<>()[]{}|/\"\\";
  static final int EMAIL_EXT=38;
  
  static final int TYPE_HTM=1; // / aspx cfm htm html php
  static final int TYPE_IMG=2; // gif jpg png
  static final int TYPE_CSS=3; // css
  static final int MAX_LINE=16000;
  
  BotenAnna myBotenAnna;
  String myAddress; // full http address of website              https://desparate.housewifes.com/archive/file.htm?year=2004
  String myFolder;  // http address without filename             https://desparate.housewifes.com/archive/
  String myDomain;  // root http address of website              https://desparate.housewifes.com/
  String myServer;  // part of domain                            housewifes.com
  Thread myThread;
  
  boolean flag_address=true;
  
  NodeAnalysis(BotenAnna myBotenAnna,String myAddress) {
    this.myBotenAnna=myBotenAnna;
    this.myAddress=myAddress;
    myThread=new Thread(this);    
    myThread.start();
  }
  
  public void run() {
    int c1,cd,cB,cS,cH,c2,c3,c4,cs,c5,c6;
    long lines=0,bytes=0;
    URL myURL;
    URLConnection myURLConnection;
    DataInputStream myDataInputStream;
    String myString,mySearch;
    String nuAddress;
    String myLog="";
    myLog+=myAddress+"\n";
    
    int cTb=-1,cTe=-1;
    String myTitle="";
    boolean flushTitle=false;
    String myToken;
    myBotenAnna.count[myBotenAnna.CONTACTED_NOW]++;
    myBotenAnna.count[myBotenAnna.CONTACTED]++;
    try {
      myFolder=myAddress.substring(0,myAddress.lastIndexOf(47)+1).toLowerCase();
      //myLog+=myFolder+"\n";
      myDomain=myFolder.substring(0,myAddress.indexOf(47,8)+1).toLowerCase();
      //myLog+=myDomain+"\n";
      myServer=myBotenAnna.getServer(myDomain);
      myLog+=" @"+myServer+"\n";
      
      // openConnection and getInputStream      
      myURL=new URL(myAddress);
      myURLConnection=myURL.openConnection();
      myURLConnection.setDoInput(true);
      myURLConnection.setUseCaches(false);      
      myURLConnection.setConnectTimeout((int)myBotenAnna.param[myBotenAnna.CONNECT_TIMEOUT]);
      myURLConnection.setReadTimeout((int)myBotenAnna.param[myBotenAnna.READ_TIMEOUT]);
      myDataInputStream=new DataInputStream(myURLConnection.getInputStream());
      // go thru document
      myBotenAnna.count[myBotenAnna.CONNECTED]++;
      while (lines<myBotenAnna.param[myBotenAnna.MAX_LINES_PER_LINK]) {
        myString=myDataInputStream.readLine();
        if (myString==null)
          break;
        lines++;
        bytes+=myString.length();
        if (bytes>myBotenAnna.param[myBotenAnna.MAX_BYTES_PER_LINK]) {
          myLog+=" jan.Exception: MAX_BYTES_PER_LINK\n";          
          break;
        }
        if (myString.length()<myBotenAnna.param[myBotenAnna.MAX_BYTES_PER_LINE]) {                    
          mySearch=myString.toLowerCase();
          // handle title          
          if (cTb<0)
            cTb=mySearch.indexOf("<title>");
          if (cTb>=0&&cTe<0&&myTitle.length()<512) {
            myTitle+=myString+" ";
            flushTitle=true;
          }
          if (cTe<0) 
            cTe=mySearch.indexOf("</title>");
          if (flushTitle) {
            myToken=myTitle.toLowerCase();
            cTb=myToken.indexOf("<title>");
            cTe=myToken.indexOf("</title>");
            if (0<=cTb&&cTb<cTe) {
              myTitle=myTitle.substring(cTb+7,cTe);
              myTitle=myTitle.replace("&amp;","&");
              myTitle=myTitle.replace("&mdash;"," ");
              myTitle=myTitle.replace("&middot;","");
              myTitle=myTitle.replace("&auml;","");
              myTitle=myTitle.replace("&ouml;","");
              myTitle=myTitle.replace("&uuml;","");
              myTitle=myTitle.replace("&Auml;","");
              myTitle=myTitle.replace("&Ouml;","");
              myTitle=myTitle.replace("&Uuml;","");
              myTitle=myTitle.replace("&oslash;","o");
              myTitle=myTitle.replace("&oacute;","o");
              myTitle=myTitle.replace("&gt;","");
              myTitle=myTitle.replace("&lt;","");
              myTitle=myTitle.replace("&nbsp;"," ");
              myTitle=myTitle.replace("&reg;","");
              myTitle=myTitle.replace("&raquo;","");              
              myTitle=myTitle.trim();
              myLog+=" ["+myTitle+"]\n";
              flushTitle=false;
            }
          }          
          // search for links and emails
          //myBoolean=true; // no email in line
          c1=0;
          while (true) {            
            cB=mySearch.indexOf("background=",c1);
            cH=mySearch.indexOf("href=",c1);
            cS=mySearch.indexOf("src=",c1);                      
            c1=MAX_LINE;
            if (cB>=0) c1=Math.min(c1,cB);
            if (cH>=0) c1=Math.min(c1,cH);
            if (cS>=0) c1=Math.min(c1,cS);          
            if (c1<MAX_LINE) {
              c2=mySearch.indexOf(34,c1); // " opening
              cd=mySearch.indexOf(62,c1); // >
              c2++;
              if (c1<c2&&c1<cd&&c2<cd) {
                c3=mySearch.indexOf(34,c2); // closing "
                if (c2<c3&&c3<cd) {
                  String myLink=myString.substring(c2,c3);
                  c4=classify(myLink);
                  if (c4==TYPE_HTM) {
                    flag_address=true;
                    nuAddress=getAddress(myFolder,myLink);
                    if (flag_address)
                      myBotenAnna.myLinkedList_add(nuAddress);
                    try {
                      myThread.sleep(5);
                    } catch(InterruptedException myInterruptedException) {
                      System.out.println(myInterruptedException);
                    }
                  }
                }
              }
              c1++;
            } else
              break;
          }
          // search for email in myString
          if (0<myString.indexOf(  64  )||
              0<myString.indexOf(" AT ")||          
              0<mySearch.indexOf(".at.")||
              0<mySearch.indexOf("-at-")||
              0<mySearch.indexOf("_at_")||
              0<mySearch.indexOf("'at'")||
              0<mySearch.indexOf("(at)")||
              0<mySearch.indexOf("[at]")||
              0<mySearch.indexOf("{at}")
             ) {
            myToken=myString.replace(" AT ","@");              
            myToken=myToken.toLowerCase();
            myToken=myToken.replace(".at.","@");
            myToken=myToken.replace("-at-","@");
            myToken=myToken.replace("_at_","@");
            myToken=myToken.replace("'at'","@");
            myToken=myToken.replace("(at)","@");
            myToken=myToken.replace("[at]","@");              
            myToken=myToken.replace("{at}","@");
            myToken=myToken.replace("%20"," ");            
            String[] mySplit=myToken.split("@",2);
            mySplit[0]=mySplit[0].substring(Math.max(mySplit[0].length()-EMAIL_EXT,0)).trim();
            mySplit[1]=mySplit[1].substring(0,Math.min(mySplit[1].length(),EMAIL_EXT)).trim();
            if (0<mySplit[0].length()&&0<mySplit[1].length()) {
              StringTokenizer myStringTokenizer;
              myToken="";
              for (c1=mySplit[0].length()-1;c1>=Math.max(0,mySplit[0].length()-EMAIL_EXT);c1--)
                myToken+=mySplit[0].charAt(c1);
              myStringTokenizer=new StringTokenizer(myToken,DELIMITER,false);
              if (myStringTokenizer.hasMoreTokens()) {
                myToken=myStringTokenizer.nextToken();
                mySplit[0]="";
                for (c1=myToken.length()-1;c1>=0;c1--)
                  mySplit[0]+=myToken.charAt(c1);
                myStringTokenizer=new StringTokenizer(mySplit[1],DELIMITER,false);
                if (myStringTokenizer.hasMoreTokens()) {                  
                  mySplit[1]=myStringTokenizer.nextToken();
                  while (mySplit[1].endsWith("."))
                    mySplit[1]=mySplit[1].substring(0,mySplit[1].length()-1);
                  if (0<mySplit[1].indexOf(46)) { // .
                    boolean valid=false;
                    myToken=mySplit[1].substring(mySplit[1].lastIndexOf(46)+1);
                    for (c1=1;c1<BotenAnna._COUNTRY.length;c1++)
                      valid|=myToken.equals(BotenAnna._COUNTRY[c1]);
                    myToken=mySplit[1].substring(mySplit[1].lastIndexOf(46));
                    for (c1=1;c1<BotenAnna._CLASS.length;c1++)
                      valid|=myToken.equals(BotenAnna._CLASS[c1]);
                    myToken=mySplit[0]+"@"+mySplit[1];                    
                    for (c1=0;c1<myToken.length();c1++)
                      if (myToken.charAt(c1)<45||122<myToken.charAt(c1))
                        valid=false;
                    if (valid) {
                      myBotenAnna.suggestMail(myToken,myTitle);
                      myLog+=" {"+myToken+"}\n";
                    }
                  }
                }
              }
            }
          }
        }
      }      
      myDataInputStream.close();
      myBotenAnna.count[myBotenAnna.COMPLETED]++;     
    } catch (MalformedURLException myMalformedURLException) {
      myLog+=" "+myMalformedURLException+"\n";
    } catch (SocketTimeoutException mySocketTimeoutException) {
      myLog+=" "+mySocketTimeoutException+"\n";
    } catch (IllegalArgumentException myIllegalArgumentException) {
      myLog+=" "+myIllegalArgumentException+"\n";
    } catch (IOException myIOException) {
      myLog+=" "+myIOException+"\n";
    } catch (Exception myException) {
      System.out.println(myException);
      myLog+=" "+myException+"\n";
    }
    myBotenAnna.count[myBotenAnna.CONTACTED_NOW]--;
    myBotenAnna.myBufferedWriter_write(myLog);
  }
  
  int classify(String myLink) {
    int c1;
    String mySearch=myLink.toLowerCase();
    c1=mySearch.indexOf(63); // ?
    if (c1>0)
      mySearch=mySearch.substring(0,c1);      
    c1=mySearch.indexOf(38); // &
    if (c1>0)
      mySearch=mySearch.substring(0,c1);
    if (//mySearch.endsWith(".asp")||
        //mySearch.endsWith(".aspx")||
        //mySearch.endsWith(".cfm")||
        mySearch.endsWith("/")||
        mySearch.endsWith(".htm")||
        mySearch.endsWith(".html")//||
        //mySearch.endsWith(".php")
       )
      return TYPE_HTM;
    if (mySearch.endsWith(".gif")||
        mySearch.endsWith(".ico")||
        mySearch.endsWith(".jpg")||
        mySearch.endsWith(".png")        
       )
      return TYPE_IMG;
    if (mySearch.endsWith(".css"))
      return TYPE_CSS;
    return 0;
  }
  
  String getAddress(String myFolder,String myLink) {
    int c1,c2=0,c3;
    c1=myLink.indexOf(58); // :
    if (0<c1&&c1<7)
      return myLink; // http: https: ftp:
    if (myLink.indexOf(47)==0)
      return getAddress(myDomain,myLink.substring(1)); // /
    if (myLink.startsWith("./"))
      return getAddress(myFolder,myLink.substring(2)); // ./
    if (myLink.startsWith("../")) {
      c3=myFolder.lastIndexOf(47,myFolder.length()-2); // ../
      if (c3>0)
        return getAddress(myFolder.substring(0,c3+1),myLink.substring(3));
      else 
        flag_address=false;
    }
    return myFolder+myLink;
  }
  
}
